<?php
/**
 *    SmilePay 金流中心-Ecmall付款模組
 *    @author    Hank,Hsu
 *    @date    2014/3/20
 */
class smilepay_creditPayment extends BasePayment
{
    /* smilepay api */
    var $_gateway   =   'https://ssl.smse.com.tw/ezpos/mtmk_utf.asp';
    var $_code      =   'smilepay_credit';
    
    function get_payform($order_info)
    {
       
        /* 商店代號 */
        $Dcvc = $this->_config['smilepay_credit_Dcvc'];
        $Rvg2c = $this->_config['smilepay_credit_Rvg2c'];		  
        /* 檢查碼 */
 		    $Verifykey = $this->_config['smilepay_credit_Verifykey'];
        /* 繳款期限 */
 		    $LimitDay = $this->_config['smilepay_credit_LimitDay'];
         
         				
        /* 商品名称 可註解*/
        //$Od_sob = $this->_get_subject($order_info);
        
        /* 總金额 */
        $Amount = $order_info['order_amount'] ;           
        $Data_id = $this->_get_trade_sn($order_info);    
	       /*買家email*/
        $email = $order_info['buyer_email'] ;	
        /* 返回的路径 */
		    $bk_posturl =$this->_create_notify_url($order_info['order_id']);  //付款結果回傳位址		 
        $roturl    = $this->_create_return_url($order_info['order_id']);   //付款完成導向地址
        
        
        $params = array(
            'Dcvc' => $Dcvc,                                 
            'Rvg2c' => $Rvg2c,     
            'Pay_zg'=> '1',              
            'Pay_gdry' => 'TW',          
            'Verify_key' => $Verifykey,                  
            'Email' => $email,
            'Data_id' => $Data_id,
            'Amount' => round($Amount),
            'Roturl' => $bk_posturl,
            'Remark' => $roturl,
            
        );
        return $this->_create_payform('GET', $params);
    }
    
    /**
     *    返回通知结果
     * 
     */ 
    function verify_notify($order_info, $strict = false)
    { 
      
  	  if (empty($order_info)){  	   
  			$this->_error('order_info_empty');
  			return false;
  		}
  		/*--START結果畫面--*/
  		 if ( $_REQUEST['type']=="returl"){
            switch ($_REQUEST["case"]){
              case "s":
                  return array(
                  'target'    =>  ORDER_ACCEPTED,
                  );
                  break;              
              case "0":
              case "1":              
                  $this->_error($_REQUEST["errdesc"]);
                  return false;
                  break;       
              case "2":
                  $this->_error($_REQUEST["errdesc"]);
                  return false;
                  break;       
              case "3":
                  $this->_error('order_inconsistent');
                  return false; 	
                  break;
              case "4":
                  $this->_error('price_inconsistent');  			
                  return false; 	
                  break;
              case "5":
                  $this->_error($_REQUEST["errdesc"]);  			
                  return false; 	
                  break;                  
              }
       }
            
      /*--End結果畫面--*/
      
  		/*--START繳款通知--*/
         $Response_id =  $_REQUEST['Response_id'];
         $Errdesc =  $_REQUEST['Errdesc'];
      if ($Response_id=="0"){  			
        $this->_error('sign_inconsistent');
  			//$_REQUEST['Remark']= $_REQUEST['Remark']."&type=returl&case=1&errdesc=". $_REQUEST['Errdesc'];
  			$_REQUEST['Remark']= $_REQUEST['Remark']."&type=returl&case=1&errdesc=".urlencode(iconv("big5","UTF-8",  $_REQUEST['Errdesc']));
  			return false;
  		}            	 
  		if($_REQUEST['Amount'] >0 && $Response_id=="1" ) {
         $Classif= $_REQUEST['Classif'];
         $Data_id= $_REQUEST['Data_id'];
         $Amount =  $_REQUEST['Amount'];    
         $Smseid       = $_REQUEST['Smseid'];
         $Mid_smilepay =  $_REQUEST['Mid_smilepay'];
        
             
         //是否啟用商家驗證參數
         $i_Mid = $this->_config['smilepay_credit_i_Mid'];
         $Mid = $this->_config['smilepay_credit_Mid'];
  			 if($i_Mid=="yes" ){
             if(!$this->midfun($Mid,$Amount,$Smseid,$Mid_smilepay)){      
                  $this->_error('sign_inconsistent');
                  $_REQUEST['Remark']= $_REQUEST['Remark']."&type=returl&case=2&errdesc=Mid_error驗證錯誤";
  			          return false;
             }     
         }                                                       		   
  		    // 通知中的订单与欲改变的订单不一致 	
         if ($order_info['out_trade_sn'] != $Data_id){            		     
            $this->_error('order_inconsistent'); 			
            $_REQUEST['Remark']= $_REQUEST['Remark']."&type=returl&case=3";
            return false;
         }
         // 支付的金额与实际金额不一致 
    		 if (abs($order_info['order_amount']) != abs($Amount)){  		      
            $this->_error('price_inconsistent');  			
            $_REQUEST['Remark']= $_REQUEST['Remark']."&type=returl&case=4";            
            return false;
         }         
         // 支付的金额与实际金额相符,付款類別相符  
    		 if ((abs($order_info['order_amount']) == abs($Amount)) && $Classif=="A"  ){
            $_REQUEST['Remark']= $_REQUEST['Remark']."&type=returl&case=s";
            return array(
               'target'    =>  ORDER_ACCEPTED,
            );
         }else{         
            $this->_error('sign_inconsistent');
            $_REQUEST['Remark']= $_REQUEST['Remark']."&type=returl&case=5&errdesc=付款錯誤";
            return false;
         }
           
    	}else{           
           return false;
      }
      /*--END繳款通知--*/  
      
	}
	
	    function verify_result($result) { 
        	 header('Location:'.$_REQUEST['Remark']);
           exit;
    }

   // compute Mid  (設定值,金額,追碼,post值)    
  function midfun($Mid_value,$Amount,$Smseid,$Mid_smilepay){   
    $Amount = str_pad($Amount,8,'0',STR_PAD_LEFT);                   
    $Smseid= preg_replace('/[\D]/i','9',substr($Smseid,-4));      
    $dtotal=$Mid_value. $Amount. $Smseid;                              
    
    $i = 1;
    $sum = strlen($dtotal);
    $etemp=0;      
    while ($i <= $sum)
    {
      $ep = substr($dtotal,$i,1);
      $etemp = $etemp + $ep;                
      $i=$i+2;
    }                
    
    $i = 0;  
    $otemp=0;          
    while ($i <= $sum)
    {                                              
      $op = substr($dtotal,$i,1);
      $otemp = $otemp + $op;
      $i=$i+2;
    } 
    
    $mid=($etemp*3)+($otemp*9);
  
    if($Mid_smilepay == $mid){
      return true;
    }else{
      return false;
    }       
  }  
        
}
?>